Subject: Re: [homenet] Comments on draft-ietf-homenet-hncp-02

From: Markus Stenberg <[email-masked]>
Date: Mon, 5 Jan 2015 11:33:19 +0200

> On 5.12.2014, at 16.17, Jonathan Hansford <[email-masked]> wrote:
>>> 1.       I notice from the homenet charter the work is based on IPv6. Is there
>> anything in the HNCP protocol that precludes its use for IPv4? I am looking for
>> a similar capability for use within multiple IPv4 broadcast domains with no
>> IPv6 in the mix at all.
>> 
>> Do you need PA, SD, or just share some arbitrary TLVs? If last, you could use
>> some existing routing link-state protocol, or possibly <unnamed thing we are
>> generalizing out of HNCP>.
> I'm currently exploring using Zeroconf capabilities to establish a single broadcast domain from scratch within an "IP island" (i.e. initially isolated from any larger internet). However, I know there will be occasions when there will be multiple broadcast domains within the island and will therefore need to be able to move from link-local to private addresses so they can be routed between the domains. Also need to perform service discovery. The one anomaly is that I need to do this prior to receiving any information from "the outside world" (e.g. allocated prefixes), hence the use of private addresses. The network needs to “discover" itself whilst it is  an island, providing full service capability within that island prior to being connected to the internet.

The current HNCP _implementation_[1] would probably do what you want, almost out of the box. It generates ULA (if no external connectivity), and deals with external v4/v6 connectivity. However, it does not do RFC1918 unless v4 external connectivity is present. Changing that would not be probably too hard, though. Of course, HNCP itself would stay v6 just due to ease of using link-local addresses.. 

It depends a lot on how much you want to write your own {solution,code} or use existing ones :)

-Markus

[1] https://github.com/sbyx/hnetd/